' Builder POC/Dev/Demo revision H by Phil Dobber (flip) at TheBackShed forum
' For MMBASIC for DOS 5.04.05 Beta 7
' This is NOT a complete production-ready program.
' Unzip this file to an empty directory(folder) and run with MMBasic.exe. Nothing else needed.
' Intended to be part of an IDE suite entirely for MicroMite/Maximite program development
' Refer http://geoffg.net/micromite.html for MMBasic uMite software and links
' TBS thread http://www.thebackshed.com/forum/forum_posts.asp?TID=9773&PN=2 for Beta version MMBASIC.EXE used
' Features:
'   Nested Includes
'   Test-runs target program then returns to the calling program
'   See end of this file for structure of the Source file
'   Only works in current directory
'   Immediate future for this component:
'     capable of working in other directories, more demos, self-installer
'   Down the track:
'     Text-based GUI integration, standard development folder structure,versions, parameter substitution...
'
' Thanks to Geoff Graham for the amazing MMBASIC!!
 
Option Explicit
Option Default NONE
 
'$MODULE Paths
 '$INCLUDE Trim
 '$INCLUDE FindLast

 Dim As STRING InitPath=CWD$   'Save Initial CurrentWorking Directory to allow for restoring at the end of program.
 Dim As STRING BasPath
 Dim As STRING BasFile
 Dim As INTEGER nParams
 Dim As STRING Params
  ' Get First Param from Command line (BAS File) and create BasPath and BasFile
  If Left$(MM.CMDLINE$,1)=Chr$(34) Then 'Double quotes - quoted file name
    nParams=Instr(2,MM.CMDLINE$,Chr$(34))
    If nParams Then
      BasFile=Mid$(MM.CMDLINE$,2,nParams-2)
    Else
      ? "Badly quoted BAS File in command line"
      END
    EndIf
  Else
    nParams=Instr(MM.CMDLINE$+" "," ")
    BasFile=Left$(MM.CMDLINE$,nParams-1)
  EndIf
  Params=Trim$(Mid$(MM.CMDLINE$+" ",nParams+1))
  nParams=FindLast("\"+BasFile,"\")
  BasPath=Left$(BasFile,nParams-1)
  BasFile=Mid$(BasFile,nParams)
  If Mid$(BasPath,2,1)<>":" Then BasPath=CWD$+"\"+BasPath ' relative path
'$END Paths

'$MODULE FindLast
FUNCTION FindLast(sSearchStr AS STRING, sToFind AS STRING, iIgnoreCase AS INTEGER) AS INTEGER
  LOCAL i%
  LOCAL AS INTEGER iLss=LEN(sSearchStr)
  LOCAL AS INTEGER iLtf=LEN(sToFind)
  LOCAL AS STRING sSS=sSearchStr
  LOCAL AS STRING sTF=sToFind
  
  IF iLtf>iLss THEN EXIT FUNCTION
  IF iIgnoreCase<>0 THEN
    sSS=UCASE$(sSearchStr)
    sTF=UCASE$(sToFind)
  ENDIF
  FOR i%=iLss-iLtf+1 to 1 STEP -1
    IF MID$(sSS,i%,iLtf)=sTF THEN FindLast=i%: EXIT FUNCTION
  NEXT i%
END FUNCTION
'$END FindLast
'Nomenclature
'MFPX - Mak File Pointer Index

Const hSRC=1
Const hMAKPTR=2
Const hMAKTXT=3
Const hTGT=4
Dim As STRING cCmt="'" 'Comment character is apostrophe for .BAS files (could be changed)
Dim As INTEGER ptrsiz=3  ' number of bytes for each text pointer into MAK file...3 allows 16 Mbyte of sourcedata text
'Const lptrOffset=ptrsiz*255+1 'first 255 pointers are reserved for source filenames
Const PtrFile="Builder.PTR"
Const MakFile="Builder.MAK"
Dim As STRING TgtFile
Dim As STRING Stack
Dim As STRING fptrs '85 pointers x 3 bytes=255 bytes
'Const MAX_FILES=20
'Dim As INTEGER SrcFilePtrOffset(MAX_FILES)
'Dim As INTEGER SrcFileLineCount(MAX_FILES)
'Dim As STRING SrcFileNames(MAX_FILES)

Dim As INTEGER NumSrcFiles '=Len(fptrs)/ptrsiz
Dim As INTEGER CurrSrcFileID 'Index to current working file
Dim As INTEGER NumTxts
Dim As INTEGER LinePtr
Dim As INTEGER WriteFlag
'*********Reusable Routines for the Builder program
Function fptr(mfpx As INTEGER) As Integer
 ' uses fptrs string as a list of indexes to the filenames
 'mfpx - Mak File Pointer Index into file pointer list
  If mfpx*ptrsiz>Len(fptrs) Or mfpx=0 Then
    fptr=0
  Else
    fptr=ChrToInt(Mid$(fptrs,mfpx*ptrsiz-ptrsiz+1,ptrsiz))
  EndIf
End Function
Function GetMT(ndx As INTEGER) As STRING
 'ndx - Index number
 ' NOTE this can be used to return anything
  Seek #hMAKPTR, ndx*ptrsiz-ptrsiz+1
  Local strt%=ChrToInt(Input$(ptrsiz, #hMAKPTR))
  Local fnsh%=ChrToInt(Input$(ptrsiz, #hMAKPTR))
  Local lngth%=fnsh%-srt%
  Seek #hMAKTXT, strt%
  GetMT=Input$(lngth%, #hMAKTXT)
End Function
Function LoadSrc(sf$) As Integer ' will return index of file (may be already loaded)
 Local As INTEGER Depth,PrevDepth
 Local As STRING sLine
 Local As STRING sCmd
 Local As STRING sParam
   
  ON ERROR SKIP
  Close #hSRC
	ON ERROR SKIP
  Open sf$ For Input As hSRC  ' may ned some chdir ability and checking.
  If MM.ERRNO Then
    ? "Couldn't open Source File '";srcf$;"':";MM.ERRMSG$;", ERR(";MM.ERRNO;")"
    End
  EndIf
	NumTxts=NumTxts+1
  fptrs=fptrs+IntToChr(NumTxts,ptrsiz)
  'Seek #hMAKPTR,  'not needed we are writing so it's just the next record
 	? #hMAKPTR, IntToChr(LOF(hMakTxt)+1,3);  ' Pointer ready for the next text
'  NumTxts,ptrsiz); 'ptrsiz=3 bytes (can have up to 16M total characters of code)
'	SrcFilePtrOffset(NumSrcFiles)=LinePtr '0th element is first line pointer
	NumSrcFiles=NumSrcFiles+1
'  SrcFileNames(NumSrcFiles)=srcf$
 	Do While Not EOF(#hSRC)
		PrevDepth=Depth
		Line Input #hSRC, sLine
    sCmd=Ucase$(GetField$(Trim$(sLine),1," "))
    sParam=Ucase$(GetField$(Trim$(sLine)+" ",2," "))
		Select Case sCmd
      Case "$TARGET", cCmt+"$TARGET": Depth=Depth+1
      Case "$MODULE", cCmt+"$MODULE": Depth=Depth+1
      Case "$INCLUDE", "'$INCLUDE": ' Add File name to list to open
      Case "$END", "'$END": Depth=Depth-1: If Depth<0 Then Depth=0
		End Select
		If Depth>0 Or PrevDepth=1 Then
			'If Left$(Ltrim$(sLine)+"  ",2)=cCmt+"$" Then sLine=Mid$(Ltrim$(sLine),2) ' remove comment character
      ? #hMAKTXT,sLine;
			? #hMAKPTR,IntToChr(LOF(hMAKTXT)+1,3);
			LinePtr=LinePtr+1
			If Depth=0 Then ?
      NumTxts=NumTxts+1
		EndIf
	Loop
	Close #hSRC
 fptrs=fptrs+IntToChr(NumTxts,ptrsiz)
 LoadSrc=NumSrcFiles
End Function
'
'*********General Purpose Routines *******************
'$MODULE GetField
'GetField$: Supply a record (rc$), field number (fld%), optional delimiter character or string (delim$)
'If fld% is positive, return JUST that field. If negative, return from ABS(fld%) right to the end of the string
FUNCTION GetField$(rc$,fld%,delim$)
 LOCAL AS INTEGER p1
 LOCAL AS INTEGER p2
 LOCAL AS INTEGER c
  IF delim$="" THEN delim$="," 'if not provided, use comma
  DO WHILE p2<LEN(rc$)
    c=c+1
    p2=INSTR(p1+1,rc$,delim$)
    if p2=0 Then p2=LEN(rc$)+1  ' Or fld%<0
    IF c=Abs(fld%) THEN
      GetField$=MID$(rc$,p1+1,p2-p1-1)
      EXIT FUNCTION
    ENDIF
    p1=p2
  LOOP
END FUNCTION
'$END GetField
Function IntToChr(iVal As INTEGER,nChrs As INTEGER) As STRING
 ' Converts an unsigned INTEGER TO a character STRING of length nChrs
 ' little-endian
 Local As INTEGER iTmp=iVal
 Local As INTEGER iRmndr
 Local i As INTEGER
  For i=1 To nChrs
    iRmndr = iTmp Mod 256
    iTmp = iTmp \ 256
    IntToChr = Chr$(iRmndr) + IntToChr
  Next i
End Function
Function ChrToInt(sVal As STRING) As INTEGER
 ' Inverse FUNCTION of IntToChr (little-endian)
 Local i As INTEGER
  For i=1 To Len(sVal)
    ChrToInt = 256*ChrToInt + Asc(Mid$(sVal,i,1))
  Next i
End Function
'$MODULE Trim
FUNCTION Ltrim$(sTxt AS STRING, sChrs AS STRING)
 LOCAL AS INTEGER i
 LOCAL AS STRING sChs=sChrs
  IF sChs="" THEN sChs=" "+CHR$(0)+CHR$(8)
  for i=1 TO LEN(sTxt)
    IF INSTR(sChs,MID$(sTxt,i,1))=0 THEN
      Ltrim$=MID$(sTxt,i)
      EXIT FUNCTION
    ENDIF
  NEXT i
END FUNCTION
FUNCTION Rtrim$(sTxt AS STRING, sChrs AS STRING)
 LOCAL AS INTEGER i
 LOCAL AS STRING sChs=sChrs
  IF sChs="" THEN sChs=" "+CHR$(0)+CHR$(8)
  for i=LEN(sTxt) TO 1 STEP -1
    IF INSTR(sChs,MID$(sTxt,i,1))=0 THEN
      Rtrim$=LEFT$(sTxt,i)
      EXIT FUNCTION
    ENDIF
  NEXT i
END FUNCTION
FUNCTION Trim$(sTxt AS STRING, sChrs AS STRING) AS STRING
  Trim$=Ltrim$(Rtrim$(sTxt, sChrs), sChrs)
END FUNCTION
'$END Trim
Sub Build(tgtname$,srcfile$)
	? "About to build '";tgtname$;"' using srcfile '";srcfile$;"'"
  If Len(Stack)=0 Then 'First Time (top-level of stack)
    ON ERROR SKIP 5 'generates MM.ERRNO=1 if file doesn't exist (which should be the norm?)
    Kill PtrFile
    Kill MakFile
    Open PtrFile For RANDOM As #hMAKPTR
    Print #PtrFile, IntToChr(1,ptrsiz) ' Pointer to first string in MakFile
    Open MakFile For RANDOM As #hMAKTXT
  EndIf
	Local As STRING sLine
  Local As STRING sCmd
  Local As STRING sParam
	Local As INTEGER AllLoaded
	Local l%=1 ' Line being inspected
	Local As INTEGER ptrL,ptrH
  Local As INTEGER strLen
  Local sf$
	' Open & Read in all Lines in the File
  If Len(Stack)=0 Then
    If srcfile$="." Then
      sf$=BasPath+BasFile
    Else
      sf$=BasPath+srcfile$
'  sf$='currFile GetField$(MM.CMDLINE$,1)
    EndIf
    CurrSrcFileID=LoadSrc(sf$)
    ? "srcfile is '";sf$;"'"
  Else
    If sf$="." Then LoadSrc=CurrSrcFileID: Exit Function
  EndIf
  Local As Integer StartLine=fptr(CurrSrcFileID)
  Local As Integer EndLine=fptr(CurrSrcFileID+1)
	' Inspect the Source file for $TARGET {each item in bldlist$ - for now tgtname$ is a single}
	? "StartLine=";StartLine;"EndLine=";EndLine
  For l%=StartLine To EndLine
		Seek #hMAKPTR, l%*ptrsiz-2
		ptrL=ChrToInt(INPUT$(ptrsiz, #hMAKPTR))
		ptrH=ChrToInt(INPUT$(ptrsiz, #hMAKPTR))
		Seek #hMAKTXT, ptrL
		'? INPUT$(ptrH-ptrL, #hMAKTXT) Doesn't work - bug
		StrLen=ptrH-ptrL
		If StrLen>0 Then
			sLine=INPUT$(StrLen, #hMAKTXT)
    Else
      sLine=""
    EndIf
'    ? sLine
    sCmd=Ucase$(GetField$(Trim$(sLine),1," "))
 		sParam=GetField$(Trim$(sLine),2," ")
    Select Case sCmd
      Case "$TARGET",cCmt+"$TARGET"
        ? "Target Name='";tgtname$;"', TgtFile='";TgtFile;"'"
        If TgtFile="" And Ucase$(GetField$(tgtname$,1))=Ucase$(sParam) Then
          TgtFile=GetField$(tgtname$,1)
          ? "Target file is :";TgtFile
          WriteFlag=-1
          ON ERROR SKIP
          Kill TgtFile
          Open TgtFile For Output As #hTGT
        EndIF
      Case "$MODULE",cCmt+"$MODULE"
        If Len(TgtFile)>0 And Ucase$(tgtname$)=Ucase$(sParam) Then
          WriteFlag=-1
          'Open TgtFile For Append As #hTGT
        EndIf
      Case "$INCLUDE",cCmt+"$INCLUDE"
       ' If Trim$(GetField$(sLine,-3))="." Then
          'Push the current address on the stack
        If WriteFlag Then
          sLine=Trim$(sLine)
          Stack=Stack+IntToChr(l%,ptrsiz)
          ? "About to Build ";: ? GetField$(sLine,2," ");: ? GetField$(sLine,-3," ")
          ? sCmd, sParam
          'Build sParam 
          WriteFlag=0
          Build GetField$(Trim$(sLine),2," "),GetField$(Trim$(sLine),-3," ")
          WriteFlag=-1
        EndIf
        '? "ToDo: Process ";sLine
      Case "$END",cCmt+"$END"
        If Ucase$(GetField$(tgtname$,1))=Ucase$(sParam) Then WriteFlag=0:Exit For 'All done
      Case Else
        If WriteFlag Then
          ON ERROR SKIP
          ? #hTGT, sLine 'Writing to file
        EndIf
		End Select
	Next l%
  If Len(Stack)=0 Then 'All done
    Close #hTGT
    Close #hMAKTXT
    Close #hMAKPTR
  Else 'pop off the stack
    Stack=Left$(Stack,Len(Stack)-ptrsiz)
  EndIf
End Sub

'Build and run demo follows....
Build "Hello.Bas", "BuilderH.BAS"
?
? "About to Run ";TgtFile;"..."
? "Press any key to continue (^C to abort)";
Do:Loop While Inkey$=""

System "C:\Users\phil\Apps\MMBasic\MMBASIC.EXE Hello.Bas Param1 Param2"
Colour 10,1
?
? "Now we're back in the calling program..."
?

'$MODULE ShowPaths
 ? "MM.CMDLINE$=";MM.CMDLINE$
 ? "CWD$=";CWD$
 ? "BasPath=";BasPath
 ? "BasFile=";BasFile
 ? "Params='";Params;"'"
'$End ShowPaths
Colour 7,0
'$MODULE HitaKey
  ? "Press any key to continue (^C to abort)";
  Do:Loop While Inkey$=""
  ?
'$END HitaKey
Quit
' No more executable code after this.

'******************** Target program **********************
$TARGET Hello.BAS
Option Explicit
Option Default NONE

	$INCLUDE Paths .
  Cursor 0,3:Colour 7,0
 Dim i As Integer
    For i=1 to 5
    ? Space$(MM.HRES)
    Next i
  Cursor 10,5:Colour 14,1
  ? "Hello World!";
	Colour 7,0
  ? " "
  Cursor 0,9
$INCLUDE ShowPaths .
?
? "About to Quit ";BasFile
$INCLUDE HitaKey .
'List
Quit 'Jump out of this shell
$END Hello.BAS
'******************** End of Target program **********************


